program test_interpolator
!

!
  USE interpolator, ONLY : interpolate, set_default_params, set_interp_params
!
  implicit none
  !  
  INTEGER, PARAMETER :: DP = selected_real_kind(14,200)

  real(8) eps
  real(8) eq
  real(8) eqx
  real(8) eqy
  real(8) eqz
  real(8) f(1000)
  real(8) fq
  real(8) datain(3,1000)
  real(8) dataout(3,1000)
  real(8) fout(1000)
  real(8) vout(1000)
  integer i,j,k,l
  
  !fq(xx,yy,zz) = ( 0.5 * ( xx**2 + yy**2 + zz**2 ))
  !
  
  l = 1
  do i=1,10
     do j=1,10
        do k=1,10
            f(l) = ( 0.5 * ( real(i)**2 + real(j)**2 + real(k)**2 ))
            datain(1,l) = real(i,DP)
            datain(2,l) = real(j,DP)
            datain(3,l) = real(k,DP)
            l = l + 1
        end do
     end do
  end do

  l = 1
  do i=1,10
     do j=1,10
        do k=1,10
            dataout(1,l) = 1.5*real(i,DP)
            dataout(2,l) = 1.5*real(j,DP)
            dataout(3,l) = 1.5*real(k,DP)
            fout(l) = ( 0.5 * ( (1.5*real(i,DP))**2 + (1.5*real(j,DP))**2 + (1.5*real(k,DP))**2 ))
            l = l + 1
        end do
     end do
  end do  
    
  CALL set_default_params()
  !
  ! Test RBF
  write(*,*) 'Testing RBF (itype 0)...'
  CALL set_interp_params(0,irbf_r0 = 2.0D0,iphitype=6)
  CALL interpolate( 3, 1000 , datain, f, 1000, dataout, 0, vout )
  l=1
  DO i=1,100
    write(*,'(A,10F10.5)') 'F', (fout(l:l+9))
    write(*,'(A,10F10.5)') 'I', (vout(l:l+9))
    write(*,'(A,10F10.5)') 'D', (vout(l:l+9) - fout(l:l+9))
    l = l + 10
  END DO
  !
  ! Test Q3
  write(*,*) 'Testing Q3 (itype 2)...'
  CALL interpolate( 3, 1000 , datain, f, 1000, dataout, 2, vout )
  l=1
  DO i=1,100
    write(*,'(A,10F10.5)') 'F', (fout(l:l+9))
    write(*,'(A,10F10.5)') 'I', (vout(l:l+9))
    write(*,'(A,10F10.5)') 'D', (vout(l:l+9) - fout(l:l+9))
    l = l + 10
  END DO
  !
end program
